Package net.shibboleth.idp.plugin.authn.webauthn.admin.impl

# Class AddAttestationConveyancePreference

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
org.opensaml.profile.action.AbstractProfileAction
org.opensaml.profile.action.AbstractConditionalProfileAction
net.shibboleth.idp.profile.AbstractProfileAction
net.shibboleth.idp.plugin.authn.webauthn.impl.AbstractWebAuthnAction<WebAuthnRegistrationContext>
net.shibboleth.idp.plugin.authn.webauthn.admin.impl.AddAttestationConveyancePreference

All Implemented Interfaces:
  `Component`, `DestructableComponent`, `InitializableComponent`, `ProfileAction`, `Aware`, `MessageSource`, `MessageSourceAware`, `Action`

public class AddAttestationConveyancePreference extends AbstractWebAuthnAction<WebAuthnRegistrationContext>
Add an attestation conveyance preference to the `context`. The default preference is 'none'.

Precondition:

      ProfileRequestContext.getSubcontext(WebAuthnRegistrationContext.class) != null

Postcondition:

      WebAuthnRegistrationContext.getAttestationConveyancePreference() != null

## Field Summary

Fields
Modifier and Type
Field
Description
`private Function<ProfileRequestContext,com.yubico.webauthn.data.AttestationConveyancePreference>`
`attestationConveyancePreferenceLookupStrategy`
A strategy to lookup the attestation conveyance preference.
`private final org.slf4j.Logger`
`log`
Class logger.

## Constructor Summary

Constructors
Constructor
Description
`AddAttestationConveyancePreference()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doExecute(ProfileRequestContext profileRequestContext, WebAuthnRegistrationContext context)`
Performs this WebAuthn authentication action using the supplied WebAuthn context.
`void`
`setAttestationConveyancePreference(String preference)`
Set the attestation conveyance preference.
`void`
`setAttestationConveyancePreferenceLookupStrategy(Function<ProfileRequestContext,com.yubico.webauthn.data.AttestationConveyancePreference> strategy)`
Set the strategy used to lookup the attestation conveyance preference.

### Methods inherited from class net.shibboleth.idp.plugin.authn.webauthn.impl.AbstractWebAuthnAction

`doExecute, doInitialize, doPreExecute, doPreExecute, enhancedCredentialRecord, getAaguidMetadata, getAaguidService, getAuthenticatorMetadata, getCredentialRepository, getFidoMetadataService, getWebAuthnClient, setAaguidService, setCredentialRepository, setFidoMetadataService, setWebAuthnClient, setWebAuthnContextLookupStrategy`

### Methods inherited from class net.shibboleth.idp.profile.AbstractProfileAction

`doExecute, execute, getBean, getBean, getMessage, getMessage, getMessage, getParameter, getParameter, getProfileContextLookupStrategy, getRequestContext, getResult, setMessageSource, setProfileContextLookupStrategy`

### Methods inherited from class org.opensaml.profile.action.AbstractConditionalProfileAction

`getActivationCondition, setActivationCondition`

### Methods inherited from class org.opensaml.profile.action.AbstractProfileAction

`doPostExecute, doPostExecute, ensureHttpServletRequest, ensureHttpServletResponse, execute, getHttpServletRequest, getHttpServletRequestSupplier, getHttpServletResponse, getHttpServletResponseSupplier, getLogPrefix, isPreExecuteCalled, setHttpServletRequestSupplier, setHttpServletResponseSupplier`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

## Field Details

### log

@Nonnull private final org.slf4j.Logger log
Class logger.

### attestationConveyancePreferenceLookupStrategy

@Nonnull private Function<ProfileRequestContext,com.yubico.webauthn.data.AttestationConveyancePreference> attestationConveyancePreferenceLookupStrategy
A strategy to lookup the attestation conveyance preference. Default is 'none'.

## Constructor Details

### AddAttestationConveyancePreference

public AddAttestationConveyancePreference()
Constructor.

## Method Details

### setAttestationConveyancePreference

public void setAttestationConveyancePreference(@Nullable String preference)
Set the attestation conveyance preference.

Parameters:
  `preference` - the attestation conveyance preference to set.

### setAttestationConveyancePreferenceLookupStrategy

public void setAttestationConveyancePreferenceLookupStrategy(@Nullable Function<ProfileRequestContext,com.yubico.webauthn.data.AttestationConveyancePreference> strategy)
Set the strategy used to lookup the attestation conveyance preference.

Parameters:
  `strategy` - The attestation conveyance preference lookup strategy to set.

### doExecute

protected void doExecute(@Nonnull ProfileRequestContext profileRequestContext, @Nonnull WebAuthnRegistrationContext context)
Performs this WebAuthn authentication action using the supplied WebAuthn context. Implementations should override this method.

Overrides:
  `doExecute` in class `AbstractWebAuthnAction<WebAuthnRegistrationContext>`
Parameters:
  `profileRequestContext` - the current IdP profile request context
  `context` - the WebAuthn context